pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT > Class Template Reference
Module keypoints

Keypoint detector for detecting corners in 3D (XYZ), 2D (intensity) AND mixed versions of these. More...

`#include <pcl/keypoints/harris_6d.h>`

Inheritance diagram for pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >:

## Public Types

typedef boost::shared_ptr< HarrisKeypoint6D< PointInT, PointOutT, NormalT > > | Ptr
typedef boost::shared_ptr< const HarrisKeypoint6D< PointInT, PointOutT, NormalT > > | ConstPtr
typedef Keypoint< PointInT, PointOutT >::PointCloudIn | PointCloudIn
typedef Keypoint< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef Keypoint< PointInT, PointOutT >::KdTree | KdTree
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
Public Types inherited from pcl::Keypoint< PointInT, PointOutT >
typedef boost::shared_ptr< Keypoint< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Keypoint< PointInT, PointOutT > > | ConstPtr
typedef PCLBase< PointInT > | BaseClass
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(int, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, int index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| HarrisKeypoint6D (float radius=0.01, float threshold=0.0)
| Constructor. More...
virtual | ~HarrisKeypoint6D ()
| Empty destructor. More...
void | setRadius (float radius)
| set the radius for normal estimation and non maxima supression. More...
void | setThreshold (float threshold)
| set the threshold value for detecting corners. More...
void | setNonMaxSupression (bool=false)
| whether non maxima suppression should be applied or the response for each point should be returned More...
void | setRefine (bool do_refine)
| whether the detected key points should be refined or not. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use. More...
Public Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
| Keypoint ()
void | harrisCorner (ImageType &output, ImageType &input, const float sigma_d, const float sigma_i, const float alpha, const float thresh)
void | hessianBlob (ImageType &output, ImageType &input, const float sigma, bool SCALE)
void | hessianBlob (ImageType &output, ImageType &input, const float start_scale, const float scaling_factor, const int num_scales)
void | imageElementMultiply (ImageType &output, ImageType &input1, ImageType &input2)
| Keypoint ()
| Empty constructor. More...
virtual | ~Keypoint ()
| Empty destructor. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for. More...
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
double | getSearchParameter ()
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors. More...
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
int | searchForNeighbors (int index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | detectKeypoints (PointCloudOut &output)
| Abstract key point detection method. More...
void | responseTomasi (PointCloudOut &output) const
void | refineCorners (PointCloudOut &corners) const
void | calculateCombinedCovar (const std::vector< int > &neighbors, float *coefficients) const
Protected Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
virtual bool | initCompute ()
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::Keypoint< PointInT, PointOutT >
std::string | name_
| The key point detection method's name. More...
SearchMethod | search_method_
| The search method template for indices. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>
class pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >

Keypoint detector for detecting corners in 3D (XYZ), 2D (intensity) AND mixed versions of these.

Author
  Suat Gedikli

Definition at line 50 of file harris_6d.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

typedef boost::shared_ptr<const HarrisKeypoint6D<PointInT, PointOutT, NormalT> > pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::ConstPtr

Definition at line 54 of file harris_6d.h.

## KdTree

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

typedef Keypoint<PointInT, PointOutT>::KdTree pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::KdTree

Definition at line 58 of file harris_6d.h.

## PointCloudIn

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

typedef Keypoint<PointInT, PointOutT>::PointCloudIn pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::PointCloudIn

Definition at line 56 of file harris_6d.h.

## PointCloudInConstPtr

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

typedef PointCloudIn::ConstPtr pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::PointCloudInConstPtr

Definition at line 59 of file harris_6d.h.

## PointCloudOut

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

typedef Keypoint<PointInT, PointOutT>::PointCloudOut pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::PointCloudOut

Definition at line 57 of file harris_6d.h.

## Ptr

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

typedef boost::shared_ptr<HarrisKeypoint6D<PointInT, PointOutT, NormalT> > pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::Ptr

Definition at line 53 of file harris_6d.h.

## Constructor & Destructor Documentation

## HarrisKeypoint6D()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::HarrisKeypoint6D | ( | float | radius = `0.01`,
|  | float | threshold = `0.0`
| ) |  |

inline

Constructor.

Parameters

  radius | the radius for normal estimation as well as for non maxima suppression
  threshold | the threshold to filter out weak corners

Definition at line 76 of file harris_6d.h.

References pcl::Keypoint< PointInT, PointOutT >::name_, and pcl::Keypoint< PointInT, PointOutT >::search_radius_.

## ~HarrisKeypoint6D()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

virtual pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::~HarrisKeypoint6D | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 89 of file harris_6d.h.

References pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setNonMaxSupression(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setRadius(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setRefine(), and pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setThreshold().

## Member Function Documentation

## calculateCombinedCovar()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::calculateCombinedCovar | ( | const std::vector< int > & | neighbors,
|  | float * | coefficients
| ) |  | const

protected

Definition at line 76 of file harris_6d.hpp.

Referenced by pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setNumberOfThreads().

## detectKeypoints()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints | ( | PointCloudOut & | output | ) |

protected virtual

Abstract key point detection method.

Implements pcl::Keypoint< PointInT, PointOutT >.

Definition at line 143 of file harris_6d.hpp.

References pcl::Feature< PointInT, PointOutT >::compute(), pcl::copyPointCloud(), pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::isFinite(), pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::resize(), pcl::PCLBase< PointInT >::setInputCloud(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setInputCloud(), pcl::NormalEstimation< PointInT, PointOutT >::setInputCloud(), pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::setInputNormals(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setNormalEstimationMethod(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setNormalSmoothingSize(), pcl::Feature< PointInT, PointOutT >::setRadiusSearch(), and pcl::PointCloud< PointT >::width.

Referenced by pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setNumberOfThreads().

## refineCorners()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::refineCorners | ( | PointCloudOut & | corners | ) | const

protected

Definition at line 361 of file harris_6d.hpp.

References pcl::PointCloud< PointT >::begin(), pcl::PointCloud< PointT >::end(), pcl::search::KdTree< PointT, Tree >::radiusSearch(), and pcl::search::KdTree< PointT, Tree >::setInputCloud().

Referenced by pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setNumberOfThreads().

## responseTomasi()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::responseTomasi | ( | PointCloudOut & | output | ) | const

protected

Definition at line 270 of file harris_6d.hpp.

References pcl::PointCloud< PointT >::height, pcl::isFinite(), pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

Referenced by pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setNumberOfThreads().

## setNonMaxSupression()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setNonMaxSupression | ( | bool | nonmax = `false` | ) |

whether non maxima suppression should be applied or the response for each point should be returned

Note
  this value needs to be turned on in order to apply thresholding and refinement

Parameters

  nonmax | default is false

Definition at line 69 of file harris_6d.hpp.

Referenced by pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::~HarrisKeypoint6D().

## setNumberOfThreads()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setNumberOfThreads | ( | unsigned int | nr_threads = `0` | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 125 of file harris_6d.h.

References pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::calculateCombinedCovar(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::refineCorners(), and pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::responseTomasi().

## setRadius()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setRadius | ( | float | radius | ) |

set the radius for normal estimation and non maxima supression.

Parameters

  radius |

Definition at line 57 of file harris_6d.hpp.

Referenced by pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::~HarrisKeypoint6D().

## setRefine()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setRefine | ( | bool | do_refine | ) |

whether the detected key points should be refined or not.

If turned of, the key points are a subset of the original point cloud. Otherwise the key points may be arbitrary. note non maxima supression needs to be on in order to use this feature.

Parameters

  do_refine |

Definition at line 63 of file harris_6d.hpp.

Referenced by pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::~HarrisKeypoint6D().

## setSearchSurface()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

virtual void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setSearchSurface | ( | const PointCloudInConstPtr & | cloud | ) |

inline virtual

Definition at line 119 of file harris_6d.h.

References pcl::Keypoint< PointInT, PointOutT >::surface_.

## setThreshold()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setThreshold | ( | float | threshold | ) |

set the threshold value for detecting corners.

This is only evaluated if non maxima suppression is turned on. note non maxima suppression needs to be activated in order to use this feature.

Parameters

  threshold |

Definition at line 51 of file harris_6d.hpp.

Referenced by pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::~HarrisKeypoint6D().

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/keypoints/include/pcl/keypoints/harris_6d.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/keypoints/include/pcl/keypoints/impl/harris_6d.hpp